diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java b/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java
index e392ce1..fc794dc 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/NistSP800_108KDF.java
@@ -1,13 +1,24 @@
 package com.netscape.cms.servlet.tks;
 
+import java.io.ByteArrayOutputStream;
+import java.io.IOException;
+import java.security.InvalidAlgorithmParameterException;
+import java.security.InvalidKeyException;
+import java.security.NoSuchAlgorithmException;
 import java.util.Arrays;
 import java.util.HashMap;
 import java.util.Map;
 
+import org.mozilla.jss.crypto.BadPaddingException;
+import org.mozilla.jss.crypto.Cipher;
 import org.mozilla.jss.crypto.CryptoToken;
+import org.mozilla.jss.crypto.EncryptionAlgorithm;
 import org.mozilla.jss.crypto.HMACAlgorithm;
+import org.mozilla.jss.crypto.IVParameterSpec;
+import org.mozilla.jss.crypto.IllegalBlockSizeException;
 import org.mozilla.jss.crypto.JSSMessageDigest;
 import org.mozilla.jss.crypto.SymmetricKey;
+import org.mozilla.jss.crypto.TokenException;
 
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
@@ -22,7 +33,18 @@ public class NistSP800_108KDF extends KDF {
 
     static final byte KDF_LABEL = 0x04; // arbitra
 
-    static final int SHA256_LENGTH = 32;
+    //SCP03, AES related constants
+
+    public static final int SHA256_LENGTH = 32;
+    private static final int AES_CMAC_BLOCK_SIZE = 16;
+    private static final byte AES_CMAC_CONSTANT = (byte) 0x87;
+    public static final byte ENC_KDF_CONSTANT = (byte) 0x04;
+    public static final byte MAC_KDF_CONSTANT = (byte) 0x06;
+    public static final byte RMAC_KDF_CONSTANT = (byte) 0x07;
+    public static final byte CARD_CRYPTO_KDF_CONSTANT = 0x0;
+    public static final byte HOST_CRYPTO_KDF_CONSTANT = 0x1;
+
+
 
     SecureChannelProtocol protocol = null;
 
@@ -57,7 +79,7 @@ public class NistSP800_108KDF extends KDF {
         String method = "NistSP800_108KDF.computeCardKeys:";
 
         if (masterKey == null || context == null || token == null) {
-            throw new EBaseException(method + " Invlalid input parameters!");
+            throw new EBaseException(method + " Invalid input parameters!");
         }
 
         Map<String, SymmetricKey> keys = new HashMap<String, SymmetricKey>();
@@ -101,9 +123,9 @@ public class NistSP800_108KDF extends KDF {
         Arrays.fill(kek, (byte) 0);
         Arrays.fill(kdf_output, (byte) 0);
 
-        SymmetricKey macKey = protocol.unwrapSymKeyOnToken(token, null, macFinal, false);
-        SymmetricKey encKey = protocol.unwrapSymKeyOnToken(token, null, encFinal, false);
-        SymmetricKey kekKey = protocol.unwrapSymKeyOnToken(token, null, kekFinal, false);
+        SymmetricKey macKey = protocol.unwrapSymKeyOnToken(token, null, macFinal, false,SymmetricKey.DES3);
+        SymmetricKey encKey = protocol.unwrapSymKeyOnToken(token, null, encFinal, false,SymmetricKey.DES3);
+        SymmetricKey kekKey = protocol.unwrapSymKeyOnToken(token, null, kekFinal, false,SymmetricKey.DES3);
 
         Arrays.fill(encFinal, (byte) 0);
         Arrays.fill(macFinal, (byte) 0);
@@ -117,6 +139,79 @@ public class NistSP800_108KDF extends KDF {
 
     }
 
+    //Compute the AES based CMAC operation. Used to derive session keys and cryptograms
+    public byte[] kdf_AES_CMAC_SCP03(SymmetricKey masterKey, byte[] context, byte kdfConstant,
+            int kdfOutputSizeBytes) throws EBaseException {
+
+        String method = "NistSP800_108KDF.kdb_AES_CMAC_SCP0:";
+        // 11 bytes label
+        byte[] label = new byte[] { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
+
+        // sanity checking
+
+        if (masterKey == null || context == null || kdfOutputSizeBytes <= 0) {
+            throw new EBaseException(method + " Invalid input!");
+        }
+
+        ByteArrayOutputStream data = new ByteArrayOutputStream();
+
+        int outputBits = kdfOutputSizeBytes * 8;
+
+        //output size of cmac PRF
+        final int h = 128;
+
+        int remainder = outputBits % h;
+
+        //calculate counter size
+        int n = 0;
+        if (remainder == 0) {
+            n = outputBits / h;
+        } else {
+            n = outputBits / h + 1;
+        }
+
+        byte b1 = (byte) ((outputBits >> 8) & 0xFF);
+        byte b2 = (byte) (outputBits & 0xFF);
+
+        byte[] outputBitsBinary = new byte[2];
+        outputBitsBinary[0] = b1;
+        outputBitsBinary[1] = b2;
+
+        try {
+            data.write(label);
+            data.write(kdfConstant);
+            data.write(0x0);
+            data.write(outputBitsBinary);
+        } catch (IOException e) {
+            throw new EBaseException(method + "Unable to calculate kdf!");
+        }
+
+        byte[] headerBytes = data.toByteArray();
+
+        ByteArrayOutputStream output = new ByteArrayOutputStream();
+        ByteArrayOutputStream input = new ByteArrayOutputStream();
+
+        byte[] kI = null;
+        for (int i = 1; i <= n; i++) {
+
+            try {
+                input.write(headerBytes);
+                input.write((byte) i);
+                input.write(context);
+
+                kI = computeAES_CMAC(masterKey, input.toByteArray());
+
+                output.write(kI);
+
+            } catch (IOException e) {
+                throw new EBaseException(method + "Unable to calculate kdf!");
+            }
+
+        }
+
+        return output.toByteArray();
+    }
+
     /*******************************************************************************
      Key Derivation Function in Counter Mode using PRF = SHA256HMAC (NIST SP 800-108)
        Calculates 384 bits of diversified output from the provided master key (K_I)
@@ -132,7 +227,6 @@ public class NistSP800_108KDF extends KDF {
         int L_BYTE_array_length = 2; // 384 = 0x0180 hex; 2 byte long representation
 
         if (context == null) {
-            throw new EBaseException(method + " Input value context  must not be null.");
         }
         // sanity check that output buffer is large enough to contain 384 bits
         if (kdfOutputSizeBytes < KDF_OUTPUT_SIZE_BYTES) {
@@ -215,4 +309,324 @@ public class NistSP800_108KDF extends KDF {
         return digestBytes;
     }
 
+    // Implements agorithm http://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38b.pdf
+    // Input an aes key of 128, 192, or 256 bits
+    // For now calling code only using 128
+    // Will move later to common class used by both tks and tps
+
+    public static byte[] computeAES_CMAC(SymmetricKey aesKey, byte[] input) throws EBaseException {
+
+        String method = "NistSP800_108KDF.computeAES_CMAC:";
+        byte iv[] = null;
+
+        if (aesKey == null || input == null) {
+            throw new EBaseException(method + " invalid input data!");
+        }
+
+        byte[] data = new byte[input.length];
+        System.arraycopy(input, 0, data, 0, input.length);
+
+        String alg = aesKey.getAlgorithm();
+        System.out.println(" AES ALG: " + alg);
+
+        EncryptionAlgorithm eAlg = EncryptionAlgorithm.AES_128_CBC;
+        int ivLength = eAlg.getIVLength();
+
+        if (ivLength > 0) {
+            iv = new byte[ivLength];
+        }
+
+        if (!("AES".equals(alg))) {
+            throw new EBaseException(method + " invalid in put key type , must be AES!");
+        }
+
+        byte[] k0 = new byte[AES_CMAC_BLOCK_SIZE];
+
+        //Encrypt the zero array
+        CryptoToken token = aesKey.getOwningToken();
+        Cipher encryptor = null;
+
+        try {
+            encryptor = token.getCipherContext(EncryptionAlgorithm.AES_128_CBC);
+            encryptor.initEncrypt(aesKey, new IVParameterSpec(iv));
+            k0 = encryptor.doFinal(k0);
+
+        } catch (NoSuchAlgorithmException | TokenException | IllegalStateException | IllegalBlockSizeException
+                | BadPaddingException | InvalidKeyException | InvalidAlgorithmParameterException e) {
+            throw new EBaseException(e);
+        }
+
+        byte[] k1 = getAES_CMAC_SubKey(k0);
+        byte[] k2 = getAES_CMAC_SubKey(k1);
+
+        int numBlocks = 0;
+        int messageSize = data.length;;
+        boolean perfectBlocks = false;
+
+        if (((messageSize % AES_CMAC_BLOCK_SIZE) == 0) && (messageSize != 0)) {
+            numBlocks = messageSize / AES_CMAC_BLOCK_SIZE;
+            perfectBlocks = true;
+        }
+        else {
+            numBlocks = messageSize / AES_CMAC_BLOCK_SIZE + 1;
+            perfectBlocks = false;
+        }
+
+        int index = 0;
+        byte inb = 0;
+
+        byte[] finalData = null;
+        ByteArrayOutputStream outputStream = new ByteArrayOutputStream( );
+
+        if (perfectBlocks == true)
+        {
+            // If the size of the message is an integer multiple of the block  block size (namely, 128 bits) (16 bytes)
+            // the last block shall be exclusive-OR'ed with the first subKey k1
+
+            for (int j = 0; j < k1.length; j++) {
+                index = messageSize - AES_CMAC_BLOCK_SIZE + j;
+                inb = data[index];
+                data[index] = (byte) (inb ^ k1[j]);
+            }
+            try {
+                outputStream.write(data);
+            } catch (IOException e) {
+                throw new EBaseException(method + " internal buffer erro!");
+            }
+            finalData = outputStream.toByteArray();
+        }
+        else
+        {
+            // Otherwise, the last block shall be padded with 10^i
+            byte[] padding = new byte[AES_CMAC_BLOCK_SIZE - messageSize % AES_CMAC_BLOCK_SIZE];
+            padding[0] = (byte) 0x80;
+
+            try {
+                outputStream.write(data);
+                outputStream.write(padding);
+            } catch (IOException e) {
+                throw new EBaseException(method + " internal buffer error!");
+            }
+
+            finalData = outputStream.toByteArray();
+
+            //Get new data size , it's changed
+            messageSize = finalData.length;
+
+            // and exclusive-OR'ed with K2
+            for (int j = 0; j < k2.length; j++) {
+                index = messageSize - AES_CMAC_BLOCK_SIZE + j;
+                inb = finalData[index];
+                finalData[index] = (byte) (inb ^ k2[j]);
+            }
+        }
+
+        // Initialization vector starts as zeroes but changes inside the loop's
+        // subsequent iterations, it becomes the last encryption output
+        byte[] encData = new byte[AES_CMAC_BLOCK_SIZE];
+        byte[] currentBlock = new byte[AES_CMAC_BLOCK_SIZE];
+        for (int i = 0; i < numBlocks; i++) {
+            try {
+                encryptor.initEncrypt(aesKey, new IVParameterSpec(encData));
+                System.arraycopy(finalData, i * AES_CMAC_BLOCK_SIZE, currentBlock, 0, AES_CMAC_BLOCK_SIZE);
+                encData = encryptor.doFinal(currentBlock);
+            } catch (TokenException | IllegalStateException | IllegalBlockSizeException
+                    | BadPaddingException | InvalidKeyException | InvalidAlgorithmParameterException e) {
+                throw new EBaseException(e);
+            }
+        }
+
+        return encData;
+
+    }
+
+    // SCP03 AES-CMAC support function
+    private static byte[] getAES_CMAC_SubKey(byte[] input) {
+
+        byte[] output = new byte[input.length];
+
+        boolean msbSet = ((input[0]&0x80) != 0);
+        for (int i=0; i<input.length; i++) {
+            output[i] = (byte) (input[i] << 1);
+            if (i+1 < input.length && ((input[i+1]&0x80) != 0)) {
+                output[i] |= 0x01;
+            }
+        }
+        if (msbSet) {
+            output[output.length-1] ^= AES_CMAC_CONSTANT;
+        }
+        return output;
+    }
+
+    // Collection of informal invocations of api used to create various session keys
+    // Done with test data.
+    public static void main(String[] args) {
+/*
+      Options options = new Options();
+
+        options.addOption("d", true, "Directory for tokendb");
+
+        String db_dir = null;
+        CryptoManager cm = null;
+
+        byte devKey[] = { (byte) 0x40, (byte) 0x41, (byte) 0x42, (byte) 0x43, (byte) 0x44, (byte) 0x45, (byte) 0x46,
+                (byte) 0x47, (byte) 0x48, (byte) 0x49, (byte) 0x4a, (byte) 0x4b, (byte) 0x4c, (byte) 0x4d, (byte) 0x4e,
+                (byte) 0x4f };
+
+        byte test_cuid[] = { (byte) 0x47,(byte) 0x90,(byte)0x50,(byte)0x37,(byte)0x72,(byte)0x71,(byte)0x97,(byte)0x00,(byte)0x74,(byte)0xA9 };
+        byte test_kdd[] = { (byte)0x00, (byte)0x00, (byte)0x50, (byte)0x24,(byte) 0x97,(byte) 0x00,(byte) 0x74, (byte) 0xA9, (byte)0x72,(byte)0x71 };
+
+
+        byte test_host_challenge[]  = { 0x06 ,(byte)0xA4 ,0x46 ,0x57 ,(byte) 0x8B ,0x65 ,0x48 ,0x51 };
+        byte test_card_challenge[]  = { (byte) 0xAD ,(byte) 0x2E ,(byte)0xD0 ,0x1E ,0x7C ,0x2D ,0x0C ,0x6F};
+
+        byte test_key_info[] = { (byte) 0x02,(byte) 03,(byte) 00 };
+        byte test_old_key_info[] = {0x01,0x03,0x00};
+
+        try {
+            CommandLineParser parser = new DefaultParser();
+            CommandLine cmd = parser.parse(options, args);
+
+            if (cmd.hasOption("d")) {
+                db_dir = cmd.getOptionValue("d");
+            }
+
+        } catch (ParseException e) {
+            System.err.println("Error in parsing command line options: " + e.getMessage());
+
+        }
+
+        SymmetricKey encKey = null;
+        SymmetricKey macKey = null;
+        SymmetricKey kekKey = null;
+
+        SymmetricKey putEncKey = null;
+        SymmetricKey putMacKey = null;
+        SymmetricKey putKekKey = null;
+
+        SymmetricKey tempKey = null;
+
+        try {
+            CryptoManager.initialize(db_dir);
+            cm = CryptoManager.getInstance();
+
+            CryptoToken token = cm.getInternalKeyStorageToken();
+
+           KeyGenerator kg = token.getKeyGenerator(KeyGenAlgorithm.AES);
+
+            SymmetricKey.Usage usages[] = new SymmetricKey.Usage[4];
+            usages[0] = SymmetricKey.Usage.WRAP;
+            usages[1] = SymmetricKey.Usage.UNWRAP;
+            usages[2] = SymmetricKey.Usage.ENCRYPT;
+            usages[3] = SymmetricKey.Usage.DECRYPT;
+
+            kg.setKeyUsages(usages);
+            kg.temporaryKeys(true);
+            kg.initialize(128);
+            tempKey = kg.generate();
+
+
+            Cipher encryptor = token.getCipherContext(EncryptionAlgorithm.AES_128_CBC);
+
+            int ivLength = EncryptionAlgorithm.AES_128_CBC.getIVLength();
+            byte[] iv = null;
+
+            if (ivLength > 0) {
+                iv = new byte[ivLength]; // all zeroes
+            }
+
+            encryptor.initEncrypt(tempKey, new IVParameterSpec(iv));
+            byte[] wrappedKey = encryptor.doFinal(devKey);
+
+            KeyWrapper keyWrap = token.getKeyWrapper(KeyWrapAlgorithm.AES_CBC);
+            keyWrap.initUnwrap(tempKey, new IVParameterSpec(iv));
+
+            encKey = keyWrap.unwrapSymmetric(wrappedKey, SymmetricKey.DES3, 16);
+            macKey = keyWrap.unwrapSymmetric(wrappedKey, SymmetricKey.DES3, 16);
+            kekKey = keyWrap.unwrapSymmetric(wrappedKey, SymmetricKey.DES3, 16);
+
+            String transportName = "TPS-dhcp-16-206.sjc.redhat.com-8443 sharedSecret";
+            SecureChannelProtocol prot = new SecureChannelProtocol(SecureChannelProtocol.PROTOCOL_THREE);
+
+            SymmetricKey masterKey =  SecureChannelProtocol.getSymKeyByName(token,"new_master");
+
+            GPParams params = new GPParams();
+            params.setVersion1DiversificationScheme("visa2");
+            params.setDiversificationScheme("visa2");
+
+            putEncKey = prot.computeSessionKey_SCP03("internal", "new_master",test_old_key_info,
+                    SecureChannelProtocol.encType, devKey, "defKeySet", test_cuid, test_kdd, null, null,
+                    transportName,params);
+
+            putMacKey = prot.computeSessionKey_SCP03("internal", "new_master",test_old_key_info,
+                    SecureChannelProtocol.macType, devKey, "defKeySet", test_cuid, test_kdd, null, null,
+                    transportName,params);
+
+            putKekKey = prot.computeSessionKey_SCP03("internal", "new_master",test_old_key_info,
+                    SecureChannelProtocol.kekType, devKey, "defKeySet", test_cuid, test_kdd, null, null,
+                    transportName,params);
+
+            //create test session keys
+            encKey = prot.computeSessionKey_SCP03("internal", "new_master",test_key_info,
+                    SecureChannelProtocol.encType, devKey, "defKeySet", test_cuid, test_kdd, test_host_challenge, test_card_challenge,
+                    transportName,params);
+
+            macKey = prot.computeSessionKey_SCP03("internal", "new_master",test_key_info,
+                    SecureChannelProtocol.macType,devKey,"defKeySet", test_cuid, test_kdd, test_host_challenge, test_card_challenge,
+                    transportName,params);
+
+            kekKey = prot.computeSessionKey_SCP03("internal", "new_master",test_key_info,
+                    SecureChannelProtocol.kekType, devKey, "defKeySet", test_cuid, test_kdd, test_host_challenge, test_card_challenge,
+                    transportName,params);
+
+            System.out.println("masterKey: " + masterKey);
+
+            System.out.println("\n");
+
+            SecureChannelProtocol.debugByteArray(putEncKey.getKeyData(), " derived putEnc session key data: ");
+            SecureChannelProtocol.debugByteArray(putMacKey.getKeyData(), " derived putMac session key data: ");
+            SecureChannelProtocol.debugByteArray(putKekKey.getKeyData(), " derived putKek session key data: ");
+
+            System.out.println("\n");
+
+            SecureChannelProtocol.debugByteArray(encKey.getKeyData(), " derived enc session key data: ");
+            SecureChannelProtocol.debugByteArray(macKey.getKeyData(), " derived mac session key data: ");
+            SecureChannelProtocol.debugByteArray(kekKey.getKeyData(), " derived kek session key data: ");
+
+            ByteArrayOutputStream contextStream = new ByteArrayOutputStream();
+            try {
+                contextStream.write(test_host_challenge);
+                contextStream.write(test_card_challenge);
+            } catch (IOException e) {
+            }
+
+            StandardKDF standard = new StandardKDF(prot);
+
+            ByteArrayOutputStream testContext = new ByteArrayOutputStream();
+
+            testContext.write(test_host_challenge);
+            testContext.write(test_card_challenge);
+
+            NistSP800_108KDF  nistKdf = new NistSP800_108KDF(prot);
+
+            byte[] finalEncBytes = nistKdf.kdf_AES_CMAC_SCP03(encKey, testContext.toByteArray(), (byte) 0x04, 16);
+            byte[] finalMacBytes = nistKdf.kdf_AES_CMAC_SCP03(macKey, testContext.toByteArray(), (byte) 0x06, 16);
+
+            SymmetricKey sEnc  = prot.unwrapAESSymKeyOnToken(token, finalEncBytes, false);
+            SymmetricKey sMac  = macKey = prot.unwrapAESSymKeyOnToken(token, finalMacBytes, false);
+
+            byte[] cardCryptoVerify = nistKdf.kdf_AES_CMAC_SCP03(sMac, testContext.toByteArray(), CARD_CRYPTO_KDF_CONSTANT, 8);
+            SecureChannelProtocol.debugByteArray(cardCryptoVerify, " calculated card cryptogram");
+
+            byte[] hostCrypto = nistKdf.kdf_AES_CMAC_SCP03(sMac, testContext.toByteArray(), HOST_CRYPTO_KDF_CONSTANT, 8);
+            SecureChannelProtocol.debugByteArray(hostCrypto, " calculated host cryptogram");
+
+        } catch (AlreadyInitializedException e) {
+            // it is ok if it is already initialized
+        } catch (Exception e) {
+            System.err.println("JSS error!" + e);
+            System.exit(1);
+        }
+*/
+    }
 }
